unit ldn191u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids,ClipBrd;

const vers='3 Oct 16';
   //started 26 Sep 16, on road to an application to
   //   vett DVD records data
   kGridMaxXIndex=15;
   kGridMaxYIndex=25;

   //Following determines color scheme for the contents
   //of the cells in the StringGrid...
   //    FG / BG: The color of the text (ForeGround) /
   //               the color of the BackGround
   //    ok/ bad: Data in the cell OK (valid) or not (BAD)
   kClBGok=clWhite;
   kClFGok=clGreen;
   kClBGbad=clRed;
   kClFGbad=clBlack;

   kFieldSep=',';//You might want to put this in a variable,
     //set it during FormCreate, maybe from an ini file. That
     //would make the application more flexible. There is a
     //"system defined" Field Separator, which varies depending
     //on what locale the machine has been set up for. You
     //could tell the application to fill kFieldSep from that.


type

  { Tldn191f1 }

  Tldn191f1 = class(TForm)
    buQuit: TButton;
    buLoad: TButton;
    buSaveWithNewName: TButton;
    buResizeCols: TButton;
    buAbout: TButton;
    buLinkToWebClick: TButton;
    sgData: TStringGrid;
    procedure buAboutClick(Sender: TObject);
    procedure buLoadClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buResizeColsClick(Sender: TObject);
    procedure buSaveWithNewNameClick(Sender: TObject);
    procedure buLinkToWebClickClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sgDataDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure sgDataSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);

  private
    { private declarations }
    clFgG,clBgG:array [0..kGridMaxXIndex,0..kGridMAxYIndex] of TColor;
    bLengthLimitInTestedColumn,bLengthTestedInWhichCol,
      bInListTestedColumn:byte;
    sTmp:string;
    sCellContentsWhenFSWarningIssued:string;//This is a nasty little
      //bit of Kludging, perhaps. See notes where it is used.
    procedure SaveStringGrid(sFilename:string);
    procedure LoadFileToStringGrid(sFileName:string);
    procedure CheckDataLength(bCol,bLen:byte);
    procedure SetCellFgBg(iCol,iRow:integer;clFg,clBg:TColor);
    procedure CheckOneCellDataLength(sTmpL:string;bLen,bCol:byte;iRow:integer);
    procedure CheckDataInList(bCol:byte);
    procedure CheckOneCellDataInList(bCol:byte;iRow:integer);
    procedure StringToSGRow(sgLocal:TStringGrid;
                             sRawData:string;iRow:integer;boTrimFields:boolean);
  public
    { public declarations }
  end;

var
  ldn191f1: Tldn191f1;

implementation

{$R *.lfm}
{$R+}
// {$R+} turns on range-checking.

{ Tldn191f1 }

procedure Tldn191f1.FormCreate(Sender: TObject);
var bLoopCountL,bLoopCountL2:byte;
begin
  sCellContentsWhenFSWarningIssued:='';
  ldn191f1.caption:='LDN191- Use StringGrid to vett data- ver: '+vers;
  application.title:='LDN191';
  for bLoopCountL:= 0 to kGridMaxXIndex do
   for bLoopCountL2:= 0 to kGridMaxYIndex do begin
     clFgG[bLoopCountL,bLoopCountL2]:=kClFGok;
     clBgG[bLoopCountL,bLoopCountL2]:=kClBGok;
   end;//for bLoopCountL2
  //(the first "for" needs no end, as it had no begin)

  bLengthTestedInWhichCol:=2;//WHERE the data to be
    //checked for length resides.
  bLengthLimitInTestedColumn:=10;//HOW LONG a datum may
    //be, without being considered unacceptable.
  bInListTestedColumn:=1;//WHERE the data to be checked
    //for being in the list of acceptable values resides.

end;

procedure Tldn191f1.SaveStringGrid(sFilename:string);
//Doing it by the "CommaText" solution causes quotation
//  marks to be inserted around fields with spaces
//  in them... which will cause
//  problems if the CSV is subsequently re-loaded
//  into this app.
//
//It might also be a good idea to check for field
//  separators within cells just before attempting
//  a save. If present, they will
//  cause a problem if you try to reload the product
//  of the save, unless fairly significant changes
//  are made to how things are saved, how they are
//  loaded. (One answer would be to enclose such
//  data in quotation marks... but that gives rise
//  to other issues... not least providing for
//  things IN quotation marks being loaded as
//  special cases.
//
//  If you use the "CommaText" version which can be
//  created from what follows, the contents of
//  cells with a field separator (if it is a comma?)
//  in it WILL be enclosed in quotes. As will
//  data with internal spaces. But, given that
//  the "load" process would have to be adapted
//  anyway, that wouldn't(?) be a problem. (But
//  I would still be inclined to avoid the
//  "CommaText" answer, if only because I know
//  that "funny things" happen when you rely
//  on the system's idea of the field separator,
//  e.g. if the system has been told it is somewhere
//  other than the USA, the field separator may
//  be something else.

var
  cardCounter:Cardinal;
  stringsTmp:TStrings;

    //Next is SR of SaveStringGrid...
    function boIsFieldSeparatorInACell(var cardRowTmp:cardinal):boolean;
    var cardRowCounter:cardinal;
        bColCounter:byte;
        boTmpL:boolean;
    begin
      boTmpL:=false;
      for bColCounter:=0 to sgData.ColCount-1 do
        for cardRowCounter:=0 to sgData.RowCount-1 do begin
           if pos(kFieldSep,sgData.cells[bColCounter,cardRowCounter])>0
              then begin
                boTmpL:=true;
                cardRowTmp:=cardRowCounter;
                end;
        end;//for bColCounter
      result:=boTmpL;
    end;// boIsFieldSeparatorInACell, SR of SaveStringGrid

    //Next is SR of SaveStringGrid...
    function sFetchRowOfCells({sgTmp:stringgrid;}cardRowL:cardinal):string;
    var bTmpL:byte;
        sTmpL:string;
      begin
        sTmpL:='';
        for bTmpL:=0 to sgData.ColCount-1 do begin
          sTmpL:=sTmpL+sgData.Cells[bTmpL,cardRowL];
          if bTmpL<>sgData.ColCount-1 then sTmpL:=sTmpL+kFieldSep;
          end;//for...
        result:=sTmpL;
      end;//sFetchRowOfCells, SR of SaveStringGrid

begin //SaveStringGrid
  //"cardCounter" used, in first line, as a "temporary"
  //   variable. What is in it, if anything, on entry
  //   to boIsFieldSeparatorInACell DOESN'T MATTER,
  //   nor do we still want what is in it afterwards.
  if boIsFieldSeparatorInACell(cardCounter) then begin
    sTmp:=kFieldSep;
    showmessage('At least one cell contains the '+
      'field separator. the field separator is '+
      sTmp+chr(13)+'The cell is in row '+
      inttostr(cardCounter));
    end;

stringsTmp:=TStringList.Create;
try
    for cardCounter := 1 to sgData.RowCount do
    begin
      //One "solution".... see sheepdogguides.com/lut/ltn4c.htm
      //   for discussion of the pros and cons of the alternatives.
      (*stringsTmp.Add(sgData.Rows[cardCounter-1].CommaText);*)
      //This is where the first solution finishes

      //Alternative solution...
      //BEFORE WE START ON THAT...
      //      a *** G E N E R A L  P O I N T ***
      //Beware how the references to the two indices of the
      //  StringGrid are managed. Where we merely need to do
      //  something once for each row or columm, I've sometimes
      //  used For Counter=1 to NumberOfThem. Other times, used
      //  For Counter=0 to NumberOfThem-1. When we need to refer
      //  to a particular cell, the fact that they are "numbered"
      //  FROM 0 needs to be remembered... and sometimes the
      //  associated "-1" to "translate" from the "name" of the
      //  row or column is done in the variable driving the "for"
      //  loop, sometimes not. Sigh.
      //
      //All of the above true as it stands when the StringGrid's
      //  FixedCols and FixedRows properties set to zero. When
      //  they are NOT, you must deal with the fact that the
      //  fixed rows/ columns are "ordinary columns/ rows" as
      //  far as the cells[x,y] array is concerned.

      sTmp:=sFetchRowOfCells({sgData,}cardCounter-1);
      stringsTmp.Add(sTmp);//"Add" appends the EOL code, too.
      end;//for
      //This is where the alternative solution finishes

    stringsTmp.SaveToFile(sFilename);
finally
    stringsTmp.free;
end;//try

showmessage('CSV re-saved, to '+sFilename+'. (If a '+
   'file of that name existed previously, it was '+
   'over-written.');
end;//SaveStringGrid

procedure Tldn191f1.buLoadClick(Sender: TObject);
//Note: After a load, if the StringGrid's option
//  goAlwaysShowEditor is set true, the contents
//  of the first cell in the grid (upper left)
//  may look funny. It is in "edit" mode, but the
//  text is un-selected. This does little harm,
//  but is annoying.
//"Look funny": If the things that were once with
//  this code which change the color of cell
//  contents are still in place, the text/ background
//  in the first cell may not be "the right" colors.
//If a way to select the text in the first cell...
//  select THE TEXT, not just the cell... could be
//  found, and added just after the LoadFileToStringGrid
//  this annoying "feature" would go away.
//Or just set goAlwaysShowEditor to "false"!
begin
LoadFileToStringGrid('TestDataLDN191.txt');
//It would be nice if a way could be found to send the cursor
//to cell 0,0 at this point... it would make the user experience
//constent. (At the momemt, after a Load, the cursor remains
//where it was previously. Seems better to me if after a load
//it is always in the same cell. ALSO, if the "go to 0,0" could
//be achieved, I hope it would go to that cell AND select the
//contents. At the moment, we are in whatever cell we are in,
//ready to edit (because we set option goAlwaysShowEditor true),
//but the text isn't selected, and the insertion point isn't flashing,
//so one cell, for no apparent reason, is black text on white
//while everything else is green on white, or red on black.
sgData.AutoSizeColumns;
CheckDataLength(bLengthTestedInWhichCol,bLengthLimitInTestedColumn);
CheckDataInList(bInListTestedColumn);
end;

procedure Tldn191f1.buAboutClick(Sender: TObject);
begin
  showmessage('This is one of many applications '+
    'available from http://SheepdogGuides.com/Lut/'+chr(13)+
    '... a collection of Lazarsus and Delphi tutorials.');
end;

procedure Tldn191f1.sgDataDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
//Thanks to http://www.festra.com/wwwboard/messages/12892.html
//  for the information used to implement this approach to coloring
//  a cell in my StringGrid.
var sTmpL:string;

begin
  //Take a note of what is in the cell at the moment...
  sTmpL:=sgData.Cells[aCol,aRow];//Yes... we do need this and the
   //".. TextOut..." line below... both here AND in SetCellFgBg

  //Paint the the "paper" to establish background color...
  sgData.canvas.brush.color:=clBgG[aCol,aRow];
  sgData.canvas.FillRect(aRect);
  sgData.canvas.font.color:=clFgG[aCol,aRow];
  sgData.canvas.TextOut(aRect.Left + 2, aRect.Top + 2,sTmpL);
    //See the note on "sTmpL:=sgData...." line above.

end;//sgDataDrawCell

procedure Tldn191f1.SetCellFgBg(iCol,iRow:integer;clFg,clBg:TColor);
//There has GOT to be a better way. In particular, I don't like the
//  globals clFgG and clBgG... but this WORKS, and is the best I
//  can manage for the moment.
//N.B. This depends for it's functioning upon the DrawCell event
//  handler "sgDataDrawCell".
var sTmpL:string;
begin
 (* 02 Oct 16, 21:13>> This (and the one below) taken out... fixes problems
       which arose during the editing of cell contents! (^_^)

       sTmpL:=sgData.Cells[iCol,iRow];

  the old comment:
       //Yes... we do need this and the
       //"sgData.Cells[iCol,iRow]:=sTmpL;" line below...
       //both here and in DrawCell

  ... appears to be WRONG. We ONLY (I hope) need it in DrawCell.
  AND it seems that it causes no problems there!!

  The slight downside is that cells are not colored to
  reflect their validity AS we edit them any more.

  A label could be set up to carry messages about any
  "bad" cell, and be immediately responsive, as we
  edited it. I think.*)

 clFgG[iCol,iRow]:=clFg;
 clBgG[iCol,iRow]:=clBg;

 (* 02 Oct 16, 21:13>> This (and the one above) taken out... fixes problems
       which arose during the editing of cell contents! (^_^)

    sgData.Cells[iCol,iRow]:=sTmpL;

    ... see note above about whys, wherefors. *)

 end;//SetCellFgBg

procedure Tldn191f1.CheckDataLength(bCol,bLen:byte);
var iLoopCounterCDL:integer;
begin
 for iLoopCounterCDL:=0 to sgData.RowCount-1 do
   CheckOneCellDataLength(sgData.Cells[bCol,iLoopCounterCDL],bLen,bCol,iLoopCounterCDL);
end;//CheckDataLength

procedure Tldn191f1.CheckDataInList(bCol:byte);
var iLoopCounterCDL:integer;
begin
 for iLoopCounterCDL:=0 to sgData.RowCount-1 do
   CheckOneCellDataInList(bCol,iLoopCounterCDL);
end;//CheckDataInList

procedure Tldn191f1.CheckOneCellDataInList(bCol:byte;iRow:integer);
//See "Bad Programming" note in CheckOneCellDataLength
var boTmpL:boolean;
  sTmpL:string;
begin
  boTmpL:=false;//Start with idea that datum is NOT valid.
  sTmpL:=sgData.Cells[bCol,iRow];
  if sTmpL='MA' then boTmpL:=true;
  if sTmpL='CA' then boTmpL:=true;
  if sTmpL='NY' then boTmpL:=true;
  //Etc. As many "if sTmpL='....' then boTmpL:=true;"
  //  as you wish, and then....

  if boTmpL=false then
    SetCellFgBg(bCol,iRow,kClFGbad,kClBGbad)//no ; here
  else
    SetCellFgBg(bCol,iRow,kClFGok,kClBGok);//no "end" here. End of "else"
end;//CheckOneCellDataInList

procedure Tldn191f1.CheckOneCellDataLength(sTmpL:string;
    bLen,bCol:byte;iRow:integer);
//"Bad Programming": Makes direct access to a global
//object, the StringGrid sgData. I am comfortable
//that in this case, "the rule" has been broken for
//sensible reasons, and in a manner which is not
//likely to be regretted. Hmmm... a very complex
//(hard to diagnose) problem arose... not(?) because
//THIS was accessing the global object(?),
//but because SetCellFg/Bg causes a repaint
//of one of the cells. Would I have noticed that
//sooner, had I not been going to the global?
//My guess? No.

//THIS NOT incorp by ref in CheckOneCellDataInList,
//  also.
begin

  if length(sTmpL)>bLen then
    SetCellFgBg(bCol,iRow,kClFGbad,kClBGbad)//no ; here
  else
    SetCellFgBg(bCol,iRow,kClFGok,kClBGok);//no "end" here. End of "else"

end;//CheckOneCellDataLength

procedure Tldn191f1.sgDataSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: string);
//This is called every time a character is changed in a cell.
//Maybe there's another event for "leaving cell, editing done"... but
//  I don't think the overheads of checking as we go along are
//  too terrible. Maybe during the load-whole-grid process they
//  will be insupportable, when more columns are being tested.
//As long as part of the reason for calling this is to check
//  that a field separator character hasn't been entered, for
//  inclusion in a cell's contents, it (the call of DataSetEditText)
//  should remain.

begin
 //Next is a just scrap of debugging code...
 //showmessage('hi.. col/row: '+inttostr(acol)+'  '+inttostr(aRow));
 //.... but NOTE FOLLOWING!  v v v v v

  //sCellContentsWhenFSWarningIssued "works" to solve a problem...
  //   but it feels like a nasty kludge
  //It was introduced to deal with the following problem:
  //Unless the SaveStringGrid and corresponding Load are re-
  //   written to allow and deal with the field separation
  //   character appearing in the "ordinary" text of any cell,
  //   we have to watch, make sure that users do not put one
  //   in.
  //A simpler version of the following "worked"... but it also
  //   "repeated itself", sometimes at unhelpful, and always
  //   at irritating moments. (The sgDataSetEditText procedure
  //   is triggered when you leave a cell, for instance... even
  //   if you are just leaving it to click the "Quit" button.)

  //If you want to make it impossible for a user to leave a cell
  //   while a field separator character remains in it, you
  //   will have to arrange that for yourself... I don't like
  //   creating that sort of situation. If you want to prevent
  //   a user from saving a "bad" StringGrid, i.e. one with
  //   field separator values in the cells, I would suggest you
  //   add (it would be easy... most of what you need is in the
  //   code already) a test at the start of the SaveStringGrid
  //   procedure, and "talk" to the user THEN if bad data present.

  if ((pos(kFieldSep,Value)>0) and
     (sCellContentsWhenFSWarningIssued<>Value))then begin
       showmessage('You have used the field separator inside '+
       'a cell. This will "work", but any CSV that you save '+
       'will be re-loaded with that cell''s contents split '+
       'across two cells, if changes haven''t been made to '+
       'the application in respect of how things are '+
       'saved and loaded to provide for field separators' +
       'in cells.');
       sCellContentsWhenFSWarningIssued:=Value;
     end;
  if aCol=bLengthTestedInWhichCol then
       CheckOneCellDataLength(Value,bLengthLimitInTestedColumn,aCol,aRow);
  if aCol=bInListTestedColumn then
       CheckOneCellDataInList(aCol,aRow);
  //You COULD have sgData.AutoSizeColumns;  here,
  //... but that would result in columns frequently re-sizing
  //    as the user entered data.... and as the program loaded
  //    the grid in the first place from the CSV file. Probably
  //    not the way to go.
end;//sgDataSetEditText

procedure Tldn191f1.LoadFileToStringGrid(sFileName:string);
(*The file to be loaded should consist of one or more
  RECORDS, each consisting of one or more FIELDS.
  The file should consist printable characters, plus
  (maybe) the code for TAB, and a FEW others like that.
  The RECORDS are separated by CR/LF terminators,
  FIELDS are separated by COMMAS. A line ending in
  a comma is considered to indicate that the final
  field of that record had nothing in it, e.g.....
    Three fields: Fred,Bloggs,860-767-5555
    Four fields: Fred,Bloggs,860-767-5555,

  ---
  See http://sheepdogguides.com/lut/lt4Nd.htm
  for details of how this part of the application
  works.

  ---
  An annoying little rough edge... not a day wrecker....
  After a load, if the StringGrid's option
    goAlwaysShowEditor is set true, the contents
    a cell in the grid may look funny. It is in
    "edit" mode, but the text is un-selected.
    This does little harm, but is annoying.
  "Look funny": If the things that were once with
    this code which change the color of cell
    contents are still in place, the text/ background
    in the first cell may not be "the right" colors.
  If a way to select the text in the first cell...
    select THE TEXT, not just the cell... could be
    found, and added just after the LoadFileToStringGrid
    this annoying "feature" would go away.
  Or just set goAlwaysShowEditor to "false"... which
    gives you a different set of good things and bad.
  *)

var
  cardCounter:Cardinal;
  stringsTmp:TStrings;
begin //LoadFileToStringGrid
  stringsTmp:=TStringList.Create;
  try
    stringsTmp.LoadFromFile(sFileName);
    sgData.RowCount:=stringsTmp.Count;//Yes: .count, not .count-1
    sgData.ColCount:=7;//This CLUMSY... But could fairly easily
      //be replaced by code to count the fields in the first
      //line, and make the StringGrid have that many columns.
      //The "built in" LoadFromCSVFile does that. Both routines
      //ignore the fact that a data file might have more
      //fields in a subsequent record. (The extra fields are
      //just thrown away in the LoadFromCSVFile. At present,
      //they cause a problem (good! You'll know about them!)
      //in this answer. (That can be fixed.)
      //What's done here, for the moment, is to set, by hand, something
      //that limits how many fields there can be in any record
      //in the CSV file. Exceed that limit, and the application
      //shuts down, in a messy way. Fall short of that on a given
      //line, and you just have some empty cells at the right hand
      //end of the line.

      //For the future: Add a parameter to LoadFileToStringGrid
      //If zero: Use the "answer" used by LoadFromCSVFile, if
      //> zero, set ColCount from that. (If this is done, also
      //provide a "scan file, find out longest (most fields) record"
      //function.)
      //
      //In any case, add a "var" variable to return error codes
      //to user.... "file not found","too many fields encountered",
      //etc.

      //Also add a parameter to specify the separator character.
      //Add a way to use....  "Bloggs, Fred",123 to allow separator
      //character inside a field? Make it optional, and tell
      //users that the application runs faster if they don't
      //use the feature? (If that change made, changes also have
      //to be made to the sub-routine for saving the contents
      //of the StringGrid to a CSV file.)

    for cardCounter:= 0 to stringsTmp.Count-1 do begin
          StringToSGRow(sgData,stringsTmp[cardCounter],cardCounter,true);
          end;

      //To be checked... what does app do when a)there is / b) there
      //  is not a CR at the end of the file?
      //(Prelim checks give the "right answer": It doesn't
      //  matter.  (^_^) (Not tested exhaustively)
      //If there is a last line consisting just of spaces, the Lazarus
      //  version does NOT add a row to the StringGrid, the
      //  SheepdogGuides version DOES add a row. ("Lazarus version":
      //  the one that uses CommaText.)

  finally
    stringsTmp.Free;
    end;//Try... finally

  //Put "sgData.AutoSizeColumns;" in your code, outside this
  //   routine, after you call LoadFileToStringGrid,
  //   if you would like all of the columns' widths adjusted,
  //   leaving each column just wide enough for the widest datum
  //   in the column.

end;//LoadFileToStringGrid

procedure Tldn191f1.StringToSGRow(sgLocal:TStringGrid;
                             sRawData:string;iRow:integer;boTrimFields:boolean);
var bColIndexL:byte;
  sOneField:string;
  boDoneIt:boolean;
//This procedure is used within "LoadFileToStringGrid". It
//  is unlikely that you would want to call it directly.

//Takes, from sRawData, a string like...
//  860-555-1912,CT,Joe Smith
//... and puts the three fields in the first three
//colums of StringGrid sgLocal.
//What's in sRawData is "eaten away" over the course of the procedure.
//If boTrimFields is true, then spaces at either end of the field datum
//  are trimmed off....
//  "   sample datum   "
//  ... would become...
//  "sample datum"

  function boChomp(var sSource:string;
        var sDest:string):boolean;//SR of StringToSGRow
  //N.B. BOTH PARAMS ARE *var* PARAMS... contents of the
  //variables used to "feed" this SR will be changed by
  //the execution of the procedure.
  //
  //The contents of sDest before the call are irrelevant.
  //
  //If the string passed to sSource has a comma at it's
  //  right hand end, then the routine assumes that to mean
  //  that there is a field after the comma, but that the
  //  contents of that field just happen to be "nothing",
  //  i.e. ''. In the processing of such a string, sSource
  //  will be passed back to the calling program with a
  //  rogue value, just before the call of Chomp which
  //  "reads" the "empty" field.
  //In other words... string "a" has three fields,
  //  string "b" has FOUR...
  //     a) Fred,Bloggs,860-767-5555
  //     b) Fred,Bloggs,860-767-5555,
  //                             ---^---
  var iPosOfComma:integer;
  //This routine uses (read only) kFieldSep. You might
  //  want to re-write things so that it is supplied
  //  to the routine as a parameter, to avoid using
  //  a global inside the routine.

  begin //main block of boChomp, SR of StringToSGRow
    if sSource='' then result:=true//no ; here
         //(See "N.B. bChomp returns...", below. THIS "true"
         //arises if you call Chomp when there was no point...
         //you already knew there was no more data to parse.
    else begin //1  (Use last field in string that started
         //String1, String2, .... , StringLast
      //(There will be no comma after last field.)

      //N.B. boChomp returns false until there is no more
      //  data to be harvested by a further call of Chomp.
      //Note especially... the first time it
      //  returns TRUE, there is STILL one field to be
      //  USED by the calling program. It has been
      //  returned to the calling program in sDest,
      //  as usual.

      if sSource='tkbRogueToIndicateNullFieldAtEndOfRaw' then
            sSource:='';
      iPosOfComma:=pos(kFieldSep,sSource);
      if iPosOfComma=0 then begin //2
           //The "=1" case arises if the string you are
           //chomping ends with a comma, which is interpreted
           //as meaning that there IS one more field in the
           //string, but it just happens to consist of nothing,
           //just happens to be ''}
        sDest:=sSource;
        sSource:='';
        result:=true;//(See "N.B. bChomp returns..." THIS "true"
          //is for the case where you have just harvested the last
          //field from the string you have been "chomping" through.
        end//no ; here. End of "then 2"
      else begin //2
          if iPosOfComma=length(sSource) then
               sSource:=sSource+'tkbRogueToIndicateNullFieldAtEndOfRaw';
          sDest:=copy(sSource,1,iPosOfComma-1);
          sSource:=copy(sSource,iPosOfComma+1,length(sSource));
          result:=false;
          end;//of "else 2"
        end;// of "else 1"
  end;//boChomp, SR of StringToSGRow

begin //main block of StringToSGRow
   bColIndexL:=0;
   boDoneIt:=false;
   repeat
     boDoneIt:=boChomp(sRawData,sOneField);//N.B: These are "var"
          //parameters. A bit is chopped off of sRawData, and
          //sOneField is filled with a new value. Also: You can
          //ignore compiler warning about sOneField not being
          //initialized.
     if boTrimfields then sOneField:=trim(sOneField);

     //If you want to "see something" when a field in the
     //  CSV says "nothing, here", de-rem the following...
     //if sOneField='' then sOneField:='null';
     sgLocal.cells[bColIndexL,iRow]:=sOneField;

     inc(bColIndexL);

   until (boDoneIt) OR (bColIndexL>8);//second term to be refined in
     //due course... at present, it is a kludge... but it WILL have
     //a role to play one day. Keep note at top of code in step.
     //(Eventually, before LoadFileToStringGrid,
     //is called, somehow a determination will be made as to how many
     //columns are to be filled. If, by chance or error, the CSV file
     //has a record with too many fields, at the moment problems arise.
     //When the "8" is replaced by a variable, and that is loaded to
     //reflect how big the StringGrid available is, then steps can be
     //taken to deal nicely with a "too big for the row" record from
     //the CSV file.
end;//StringToSGRow

procedure Tldn191f1.buResizeColsClick(Sender: TObject);
begin
  showmessage('This button does resize the columns, but '+
  'it would be nice if the panel they appeared on was also '+
  'resized. Haven''t cracked that bit fully yet. '+
  'Currently.. and for the future, probably, that '+
  'can be resized by resizing the application''s window. '+
  'Not central to application.');
  sgData.AutoSizeColumns;//Leave this statement. Ref'd in ltN4c.htm
  //Next line: Crude, and not discussed in turtorial... but "works"
  //  to make width of stringgrid right for columns on it.
  //Doing same for height possible, more tedious.
  //The code for both needs to be in a better place, too... this
  //  just shows how it could be done.

  //The following DOES resize the PANEL the grid is displayed on,
  //  but there are "issues"... not only does it need to be
  //  generalized for the current number of columns, but there
  //  needs to be interaction between this code and the current
  //  window size, ESPECIALLY if the anchor editor has "turned on"
  //  "fit panel to window". (It might be easiest to turn OFF the
  //  anchor editor's "help", for this object, and "do it by hand".
  //
  //sgData.width:=sgData.ColWidths[0]+sgData.ColWidths[1]+
  //        sgData.ColWidths[2];

end;

procedure Tldn191f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure Tldn191f1.buSaveWithNewNameClick(Sender: TObject);
begin
   SaveStringGrid('TmpLDN191SavedFile.txt');
end;

procedure Tldn191f1.buLinkToWebClickClick(Sender: TObject);
begin
  Clipboard.AsText:='http://sheepdogguides.com/lut/lt4Nc.htm';
end;


end.

